package demo;

import java.util.Iterator;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;

import org.apache.commons.jxpath.JXPathContext;
import org.apache.commons.jxpath.Pointer;

import org.jaxen.XPathSyntaxException;
import org.jaxen.JaxenException;
import org.jaxen.dom.html.HTMLXPath;

import org.enhydra.xml.xmlc.StreamXMLCLogger;
import org.enhydra.xml.xmlc.XMLObject;
import org.enhydra.xml.xmlc.StreamXMLCLogger;
import org.enhydra.xml.xmlc.deferredparsing.XMLCDeferredParsingFactory;

public class Test
{
    static private XMLCDeferredParsingFactory xmlcFactory = null;

    protected XMLCDeferredParsingFactory getFactory() {
	if (xmlcFactory != null) {
	    return xmlcFactory;
	}

	PrintWriter writer = new PrintWriter(new OutputStreamWriter(System.err));
	StreamXMLCLogger logger = new StreamXMLCLogger(writer, writer, writer);
	xmlcFactory = new XMLCDeferredParsingFactory(null, this.getClass().getClassLoader(), logger);

	xmlcFactory.addResourceDir(".");
	xmlcFactory.addResourceDir("./input");
	xmlcFactory.setDefaultMetaDataPath("input/options.xmlc");
	return xmlcFactory;
    }

    public void run (String[] args) {
        XMLObject xmlObject = null;
        for (int i = 0 ; i < 2 ; i ++) {
            System.out.println ("-----");
            xmlObject = getFactory().createFromFile(args[0]);
            System.out.println (xmlObject.toDocument());
        } // end of for ()
    }

    public static void main(String[] args) {
        Test test = new Test();
        test.run(args);

    } // end of main()
    
}
